'rdbase.bas - barebones xbase .dbf file reader
'
'requires PowerBasic 2.1 or higher to compile
'
'Met my need for a quick and dirty .dbf reader.  Handles char and simple
'number fields, no date, no memos.
'Needs menus for file selection, search criteria, printing options,
'data field editing, etc., if you want to use it for serious work.
'Writing changed data back to the .dbf is a matter of changing the bytes in
'rec$, seeking to that record's position in the file, and doing a put of rec$.
'Copyright 1994 - John E. Carter
'Released to the public domain 9-25-94
'It's probably worth the price I ask :-)
'johnecarter@mindspring.com
'
defint a-z
cmd$=command$                   'check for command line argument
color 7,1
cls
if cmd$="" then
  input "XBase file to read: ",inf$
else
  inf$ = cmd$
end if
if inf$="" then end             'quit if no input
dotloc = instr(inf$,".")        'fixup file name, if needed
if dotloc = 0 then inf$ = inf$ + ".dbf"
k$ = dir$(inf$)                 'check that it exists
if k$="" then
  print inf$;" not found"
  end
end if
'format of xbase file header bytes
'version: 3 = dbase III, 83 = dbase III w/memo
map x$$ * 32, 1 as version$$, 3 as ymd$$, 4 as numrecs$$, 2 as hdrlen$$,_
    2 as reclen$$, 20 as reserve$$
'format of xbase field description header, 1 per field
map fldfmt$$ * 33, 11 as fldname$$, 1 as fldtype$$, 4 as dfa$$,_
    1 as fldlen$$, 1 as flddec$$, 14 as reserv$$, 1 as crlf$$
open inf$ for binary as 1
' get header info
get$ #1, 32, x$$
print "File: ";inf$
print "version: ";ascii(version$$),
print"last update: ";ascii(mid$(ymd$$,2,1));"-";ascii(right$(ymd$$,1));"-";ascii(left$(ymd$$,1)),
print "records: ";cvl(numrecs$$)
print "header length: ";cvi(hdrlen$$), "record length: ";cvi(reclen$$),
' get field names and descriptions
headerlen=cvi(hdrlen$$)         'length of total header
recordlen=cvi(reclen$$)         'length of one record
numrec& = cvl(numrecs$$)
numfields = (headerlen -32) /32  'count of fields from header byte count
print "fields: ";numfields
'create arrays to store field info
dim fxname$(numfields), ftype$(numfields), flen(numfields), dlen(numfields)
dim thisrec$(numfields)
fldnumb=1
'get field info into arrays
while seek(1) < headerlen -2   'don't go past end of header bytes
  get$ 1,32,fldfmt$$
  fxname$(fldnumb) = fldname$$     'field name (11 chars, uppercase)
  ftype$(fldnumb) = fldtype$$      'field type (1 char, uppercase)
  flen(fldnumb) = ascii(fldlen$$)  'field length (1 byte)
  dlen(fldnumb) = ascii(flddec$$)  'decimal places (1 byte)
'uncomment the next line to display the structure of the .dbf file
'  print fldnumb;" ";fldname$$, fldtype$$,ascii(fldlen$$);" "; ascii(flddec$$) ', seek(1)
  incr fldnumb
wend
input "Press Enter for records",xx$
'get records
seek #1, headerlen     'get past the header bytes
curpos = 1
currec& = 0
'print time$
while eof(1) <> -1
  cls
  get$ 1, 1, delet$                    'get the deleted status byte
  get$ 1,recordlen -1, rec$               'read one record
  incr currec&                          'keep track of current record #
    for k = 1 to fldnumb                      'read bytes for each field
      thisrec$(k) = mid$(rec$,curpos, flen(k))
'     if left$(rec$,6) = "Carter" then   'search on field content, if desired
'       isfound = 1                      'need sub to set up search
'       display data only if match
'     end if
      curpos = curpos + flen(k)               'update position in rec$
      if pos(0) > (68 - flen(k)) then print   'force newline if not enough room
      if ftype$(k)="C" then                   'need CASE for all types (date, etc)
	color 7,1:print fxname$(k);":";
	color 1,7:print thisrec$(k);
	color 7,1:print "|";
      elseif ftype$(k) = "N" then
	color 7,1:print fxname$(k);":";
	color 1,7:print thisrec$(k);
	color 7,1:print "|";
      end if
      if csrlin > 20 then  'more fields/data than will fit on one screen
	print
	input "Press Enter for next page of data",xx$
	cls
      end if
    next k
    print
    curpos = 1                                'back to beginning of string
    if delet$ = "*" then color 7,2            'flag deleted records
    print "Record # ";currec&
    if delet$ = "*" then color 7,1
    if currec& = numrec& then print "Last record"
    input "More (n/-/#)? ",xx$      'should have "search on any field" menu
				    'and allow for selecting another file
    xval = val(xx$)                 'allow for selecting a record number
    if xval > 0 then                'only on positive #
      nextpos& = headerlen + ((xval -1) * recordlen)
      if nextpos& > lof(1) then           'need sub to show max record #
	print "Record number too high"    'and prompt for next valid #
	end                               'or just return to 1st record
      end if
      seek #1, nextpos&
      currec& = (nextpos& - headerlen) / recordlen
    end if
'    if len(xx$) > 1 then                 'let this be data to search for
'      do search
'    else                                 'continue with existing code
    ux$ = ucase$(xx$)
    if ux$="N" or ux$="Q" then end         'could have complete menu here
    if xx$ = "-" then                      'allow backup to previous record
      if currec& > 1 then
	seek #1, seek(1) - recordlen*2     'backup over current & previous
	decr currec&, 2                    'to start of previous record
      else
	seek #1, seek(1) - recordlen       'else go back to start of record 1
	decr currec&
      end if
    end if
'  end if                                  'end of check for search data
  if currec& = numrec& then print "DONE":end   'quit if last record displayed
wend
print "BYE"


